﻿
// uisdkdemo.cpp: 定义应用程序的类行为。
//

#include "pch.h"
#include "framework.h"
#include "uisdkdemo.h"
#include "uisdkdemodlg.h"

#pragma warning( disable : 4996 )

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CuisdkdemoApp

BEGIN_MESSAGE_MAP(CUISdkDemoApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CuisdkdemoApp 构造

CUISdkDemoApp::CUISdkDemoApp()
{
	// 支持重新启动管理器
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;

	// TODO: 在此处添加构造代码，
	// 将所有重要的初始化放置在 InitInstance 中
}


// 唯一的 CuisdkdemoApp 对象

CUISdkDemoApp theApp;

static void KdvMtCALL SdkMsgCallBack(u32 dwEvent, const u8* pMsgBody, u32 dwMsgLen)
{
	// SDK中回调上来的消息统一交给主窗口CpcsdkdemoDlg去分发，由CpcsdkdemoDlg分发到
	// 相关的需要关注消息的窗口中
	CWnd* pWnd = AfxGetMainWnd();
	if (pWnd != NULL)
	{
		::SendMessage(pWnd->m_hWnd, dwEvent, (WPARAM)pMsgBody, (LPARAM)dwMsgLen);
	}
}

// 获取 桌面、开始->程序组等系统路径  
// 参数：int nFolder，对应CSIDL_COMMON_PROGRAMS、CSIDL_COMMON_DESKTOPDIRECTORY等
BOOL GetTargetSpecialFolder(TCHAR* pchFolderPath, int nPathBufLen, int nFolderType)
{
	ASSERT(pchFolderPath != NULL);
	ASSERT(nPathBufLen > 0);
	if (pchFolderPath == NULL || nPathBufLen <= 0)
	{
		return FALSE;
	}

	LPITEMIDLIST  ppidl;
	if (SHGetSpecialFolderLocation(NULL, nFolderType, &ppidl) == S_OK)
	{
		TCHAR achTargetPath[MAX_PATH * 2] = { 0 };
		BOOL bRet = SHGetPathFromIDList(ppidl, achTargetPath);
		if (bRet)
		{
			int nCpyLen = min(nPathBufLen - 1, sizeof(achTargetPath) / sizeof(TCHAR) - 1);
			_tcsncpy(pchFolderPath, achTargetPath, nCpyLen);
			pchFolderPath[nCpyLen] = _T('\0');
		}

		CoTaskMemFree(ppidl);
		return bRet;
	}

	return FALSE;
}

// TCHAR* pachDir[out]：配置文件和历史记录文件的存放路径
// int nDirBufLen[in]:  pachDir的长度，是字符个数，不是字节数
BOOL GetTargetDir(TCHAR* pchDir, int nDirBufLen, const TCHAR* pchProductName)
{
	ASSERT(pchDir != NULL);
	ASSERT(nDirBufLen > 0);
	ASSERT(pchProductName != NULL);
	if (pchDir == NULL || nDirBufLen <= 0 || pchProductName == NULL)
	{
		return FALSE;
	}

	// 1、debug下将图片及配置文件放置在exe所在目录
	// 2、对于xp系统，图片及配置文件也放置在exe所在目录
	// 3、对于win7及以上系统，可能会涉及到管理员权限，所以图片及配置文件要放置公共文档目录中
#ifndef _DEBUG  // 为了方便代码的开发和调试，将debug下的目录放在exe当前目录中
	// 判断当前系统是否是win7以上系统
	BOOL bOsWin7OrAbove = FALSE;
	OSVERSIONINFOEX osvi;
	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	GetVersionEx((OSVERSIONINFO*)&osvi);
	/*****************************************************************************
	Operating System             Version     PlatformID
	Windows 8                    6.2         VER_PLATFORM_WIN32_NT (=2)
	Windows 7                    6.1         VER_PLATFORM_WIN32_NT
	Windows Vista                6.0         VER_PLATFORM_WIN32_NT
	Windows XP 64-Bit Edition    5.2         VER_PLATFORM_WIN32_NT
	Windows XP                   5.1         VER_PLATFORM_WIN32_NT
	******************************************************************************/
	// win7的系统版本为NT6.1 win8为6.2
	if (VER_PLATFORM_WIN32_NT == osvi.dwPlatformId &&
		((osvi.dwMajorVersion == 6 && osvi.dwMinorVersion >= 0)
			|| osvi.dwMajorVersion > 6))
	{
		bOsWin7OrAbove = TRUE;
	}

	if (bOsWin7OrAbove) // win7及以上系统
	{
		// win7及以上系统，使用public文档路径（C:\Users\Public\Documents）
		TCHAR achPath[MAX_PATH * 2] = { 0 };
		BOOL bRet = GetTargetSpecialFolder(achPath, sizeof(achPath) / sizeof(TCHAR), CSIDL_APPDATA);
		if (bRet)
		{
			_sntprintf_s(pchDir, nDirBufLen, nDirBufLen - 1, _T("%s\\%s\\"), achPath, /*PCMT_PRODUCT_ENG_NAME*/pchProductName);
			pchDir[nDirBufLen - 1] = _T('\0');
			return TRUE;
		}
		else
		{
			ASSERT(bRet == FALSE);
			return FALSE;
		}
	}
	else
#endif
	{
		// 在xp系统中，历史记录文件和配置文件还维持在安装目录下
		//strCfgHisFileDir = GetModuleFullPath();
		TCHAR achDllName[MAX_PATH] = { 0 };
		GetModuleFileName(NULL, achDllName, MAX_PATH - 1);

		TCHAR* pchRet = _tcsrchr(achDllName, _T('\\')); // 逆向找到“\\”
		if (pchRet != NULL)
		{
			int nCpyLen = min(pchRet - achDllName, nDirBufLen - 2);
			_tcsncpy(pchDir, achDllName, nCpyLen);
			pchDir[nCpyLen] = _T('\\'); // 手动加上“\\”
			pchDir[nCpyLen + 1] = _T('\0');
			return TRUE;
		}
		else
		{
			ASSERT(pchRet == FALSE);
			return FALSE;
		}
	}
}

BOOL CopyFileToDstDir(const CString& strSrcDirRelPath, const CString& strSrcPath, const CString& strDstPath)
{
	CString strLog;

	CString strFindFileName = strSrcPath + _T('\\') + strSrcDirRelPath
		+ _T("\\*.*"); // strSrcDirRelPath是相对路径
	WIN32_FIND_DATA wfd;
	HANDLE hFindFile = FindFirstFile(strFindFileName, &wfd);
	if (hFindFile == INVALID_HANDLE_VALUE)
	{
		return TRUE;
	}

	while (1)
	{
		if (wfd.cFileName[0] != '.')
		{// 非本级或上级目录	
			CString strSrcFileRelPath = strSrcDirRelPath + _T('\\') + wfd.cFileName; // 文件相对路径
			CString strSrcFilePath = strSrcPath + _T('\\') + strSrcFileRelPath;
			CString strDstFileAbsPath = strDstPath + _T('\\') + strSrcFileRelPath;

			if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) // 目录
			{
				// 检测文件夹是否存在，不存在则需要创建
				WIN32_FIND_DATA wfdtmp;
				HANDLE hFindFile = FindFirstFile(strDstFileAbsPath, &wfdtmp);
				if (hFindFile == INVALID_HANDLE_VALUE)
				{
					// 文件夹不存在，则创建文件夹
					CreateDirectory(strDstFileAbsPath, NULL);
				}

				// 对于文件夹，递归查找文件夹中的文件
				BOOL bRet = CopyFileToDstDir(strSrcFileRelPath, strSrcPath, strDstPath);
				if (!bRet)
				{
					FindClose(hFindFile);
					return FALSE;
				}
			}
			else // 文件
			{
				// 将更新文件夹中的文件Move到安装目录中，如果文件已存在，则进行覆盖操作
				//BOOL bRet = MoveFileEx( strSrcFilePath, strDstFileAbsPath, MOVEFILE_REPLACE_EXISTING|MOVEFILE_COPY_ALLOWED );
				BOOL bRet = CopyFile(strSrcFilePath, strDstFileAbsPath, FALSE);
				if (!bRet) // 覆盖成功
				{
					FindClose(hFindFile);
					return FALSE;
				}
			}
		}

		if (!FindNextFile(hFindFile, &wfd))
		{
			break;
		}
	}

	FindClose(hFindFile);
	return TRUE;
}

// CuisdkdemoApp 初始化

BOOL CUISdkDemoApp::InitInstance()
{
	// 如果一个运行在 Windows XP 上的应用程序清单指定要
	// 使用 ComCtl32.dll 版本 6 或更高版本来启用可视化方式，
	//则需要 InitCommonControlsEx()。  否则，将无法创建窗口。
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// 将它设置为包括所有要在应用程序中使用的
	// 公共控件类。
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();


	AfxEnableControlContainer();

	// 创建 shell 管理器，以防对话框包含
	// 任何 shell 树视图控件或 shell 列表视图控件。
	CShellManager *pShellManager = new CShellManager;

	// 激活“Windows Native”视觉管理器，以便在 MFC 控件中启用主题
	CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));

	// 标准初始化
	// 如果未使用这些功能并希望减小
	// 最终可执行文件的大小，则应移除下列
	// 不需要的特定初始化例程
	// 更改用于存储设置的注册表项
	// TODO: 应适当修改该字符串，
	// 例如修改为公司或组织名
	SetRegistryKey(_T("应用程序向导生成的本地应用程序"));

	// 设置SDK回调函数
	SetSDKMsgCallBack(SdkMsgCallBack);
	//KdvMt_Pc_Set_App_Icon("E:\\SVN_Home\\20210706_TL_WebRTC_V7R0_SP3\\90-truelink\\uisdk\\uisdkdemo\\prj_win32\\res\\pcmtwnd.ico");
	// 初始化SDK，收到EV_PCSDK_UI_INIT_FIN消息后表示SDK初始化完成，初始化完成后才能进行操作
    InitMeetingSDK();

// 将SDK包中bin路径下的conf文件夹和pic文件夹中的文件拷贝到指定的目标路径中
// 注意：此处用代码自动拷贝，只是为了sdkdemo能正常运行，对于最终的sdk用户，conf文件夹的拷贝
// 操作应该放置到安装包中去做，至于指定的目标路径，查看下面函数内部的注释与实现
#ifndef _DEBUG 
	// release下才需要拷贝到目标目录中，debug下只要将conf文件夹
	// 放置在sdkdemo.exe所在目录中
	OSVERSIONINFOEX osvi;
	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	GetVersionEx((OSVERSIONINFO*)&osvi);
	// win7以上系统因为写权限问题，需要执行文件夹的拷贝
	if (VER_PLATFORM_WIN32_NT == osvi.dwPlatformId &&
		((osvi.dwMajorVersion == 6 && osvi.dwMinorVersion >= 0)
			|| osvi.dwMajorVersion > 6))
	{
		CopyConfAndPicDirFilesToTargetDir();
	}
#endif // _DEBUG

	CUISdkDemoDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: 在此放置处理何时用
		//  “确定”来关闭对话框的代码
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: 在此放置处理何时用
		//  “取消”来关闭对话框的代码
	}
	else if (nResponse == -1)
	{
		TRACE(traceAppMsg, 0, "警告: 对话框创建失败，应用程序将意外终止。\n");
		TRACE(traceAppMsg, 0, "警告: 如果您在对话框上使用 MFC 控件，则无法 #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS。\n");
	}

	// 删除上面创建的 shell 管理器。
	if (pShellManager != nullptr)
	{
		delete pShellManager;
	}

#if !defined(_AFXDLL) && !defined(_AFX_NO_MFC_CONTROLS_IN_DIALOGS)
	ControlBarCleanUp();
#endif

	// 由于对话框已关闭，所以将返回 FALSE 以便退出应用程序，
	//  而不是启动应用程序的消息泵。
	return FALSE;
}

// 将SDK包中bin路径下的conf文件夹和pic文件夹中的文件拷贝到指定的路径中
void CUISdkDemoApp::CopyConfAndPicDirFilesToTargetDir()
{
	// 检查当前exe路径下是否有conf文件夹
	CString strConfPath = GetModuleFullPath();
	strConfPath += _T("conf");
	if (!PathFileExists(strConfPath))
	{
		return;
	}

	// release下才需要拷贝到指定的路径中
#ifndef _DEBUG
	// demo中在此处判断了版本的类型，客户在实际使用时已经确定使用哪个版本，不用调用SDK接口做判断
	CString strProductName;
	if (IsEnterpriseVer())
	{
		strProductName = _T("mo_TrueLSDK");
	}
	else
	{
		strProductName = _T("Kedacom_SKYSDK");
	}

	// 指定的路径为：%appdata%\Kedacom_SKYSDK（自建版本），或者
	// %appdata%\mo_TrueLSDK（运营版本）
	// 注意：必须拷贝到该指定的路径中，这是SDK内部固定的路径
	TCHAR achTargetPath[MAX_PATH] = { 0 };
	GetTargetDir(achTargetPath, sizeof(achTargetPath) / sizeof(TCHAR), (LPCTSTR)strProductName);

	// 1、先处理conf文件夹中文件的拷贝
	CString strTargetConfDir = achTargetPath;
	strTargetConfDir += _T("conf");
	if (!PathFileExists(strTargetConfDir))
	{
		BOOL bRet = CreateDirectory(strTargetConfDir, NULL);
		if (!bRet)
		{
			return;
		}
	}

	CString strSrcPath = strConfPath;
	CString strDstPath = strTargetConfDir;
	// 对于最开始，strSrcDirRelPath传入空，因为当前在源文件夹的最顶层
	CopyFileToDstDir(_T(""), strSrcPath, strDstPath);

	// 2、再处理pic文件夹中文件的拷贝
	CString strPicPath = GetModuleFullPath();
	strPicPath += _T("pic");
	if (!PathFileExists(strPicPath))
	{
		return;
	}

	CString strTargetPicDir = achTargetPath;
	strTargetPicDir += _T("pic");
	if (!PathFileExists(strTargetPicDir))
	{
		BOOL bRet = CreateDirectory(strTargetPicDir, NULL);
		if (!bRet)
		{
			return;
		}
	}

	strSrcPath = strPicPath;
	strDstPath = strTargetPicDir;
	// 对于最开始，strSrcDirRelPath传入空，因为当前在源文件夹的最顶层
	CopyFileToDstDir(_T(""), strSrcPath, strDstPath);
#endif
}

