﻿// createconfdlg.cpp: 实现文件
//

#include "pch.h"
#include "uisdkdemo.h"
#include "createconfdlg.h"
#include "afxdialogex.h"


// CCreateConfDlg 对话框

IMPLEMENT_DYNAMIC(CCreateConfDlg, CDialogEx)

CCreateConfDlg::CCreateConfDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_CREATE_CONF_DLG, pParent)
{

}

CCreateConfDlg::~CCreateConfDlg()
{
}

void CCreateConfDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_CONF_TIME_LENGTH, m_cmbConfTimeLen);
	DDX_Control(pDX, IDC_EDIT_CONF_NAME, m_editConfName);
}


BEGIN_MESSAGE_MAP(CCreateConfDlg, CDialogEx)
	ON_BN_CLICKED(IDOK, &CCreateConfDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CCreateConfDlg 消息处理程序


BOOL CCreateConfDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	m_cmbConfTimeLen.InsertString(0, _T("1小时"));
	m_cmbConfTimeLen.InsertString(1, _T("2小时"));
	m_cmbConfTimeLen.InsertString(2, _T("3小时"));
	m_cmbConfTimeLen.InsertString(3, _T("4小时"));
	m_cmbConfTimeLen.InsertString(4, _T("6小时"));
	m_cmbConfTimeLen.InsertString(5, _T("8小时"));

	m_cmbConfTimeLen.SetCurSel(3);

	m_editConfName.SetFocus();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // 异常: OCX 属性页应返回 FALSE
}


void CCreateConfDlg::OnBnClickedOk()
{
	CString strConfName;
	m_editConfName.GetWindowText(strConfName);
	strConfName.Trim();
	if ( strConfName.IsEmpty() )
	{
		m_editConfName.SetFocus();
		AfxMessageBox(_T("会议名称不能为空，请输入会议名称"));
		return;
	}

	// 注意：会议名称的字符个数不能超过32个（是字符个数，不是字节数）
	// 这是平台的要求，创会时要做这样的检测
	if (strConfName.GetLength() > 32 )
	{
		m_editConfName.SetFocus();
		AfxMessageBox(_T("会议名称中的字符个数不能超过32个，请重新输入"));
		return;
	}

	u32 dwConfDuration = 4 * 60; // 单位：分钟，会议时长默认为4个小时
	int nCurSel = m_cmbConfTimeLen.GetCurSel();
	if ( nCurSel >= 0 && nCurSel <= 3 )
	{
		dwConfDuration = (nCurSel + 1) * 60;
	}
	else if ( nCurSel == 4 )
	{
		dwConfDuration = 6 * 80;
	}
	else if ( nCurSel == 5 )
	{
		dwConfDuration = 8 * 60;
	}

	m_strConfName = strConfName;

	TCreateConfInfo_SDK tCreateConfInfo;
	CopyCStringTToUtf8(tCreateConfInfo.achConfName, strConfName, sizeof(tCreateConfInfo.achConfName));
	tCreateConfInfo.dwConfDuration = dwConfDuration;
	CreateConf(&tCreateConfInfo);
	CDialogEx::OnOK();
}
